# coding: utf-8

"""
    Artifact Client API

    API for interacting with the Artifact Client.

    The version of the OpenAPI document: 2.4.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import re  # noqa: F401
import json
import pprint
from typing import Any, Set, Dict, List, ClassVar, Optional
from datetime import datetime
from typing_extensions import Self, Annotated

from pydantic import Field, BaseModel, StrictStr, ConfigDict


class DocumentMeta(BaseModel):
    """
    DocumentMeta
    """  # noqa: E501

    account_id: Optional[StrictStr] = None
    file_name: Optional[StrictStr] = None
    metadata: Optional[Dict[str, Any]] = None
    namespace: Optional[StrictStr] = None
    size_bytes: Optional[Annotated[int, Field(strict=True, ge=0)]] = None
    status: Optional[StrictStr] = None
    upload_time: Optional[datetime] = None
    uuid: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = [
        "account_id",
        "file_name",
        "metadata",
        "namespace",
        "size_bytes",
        "status",
        "upload_time",
        "uuid",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DocumentMeta from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DocumentMeta from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "account_id": obj.get("account_id"),
                "file_name": obj.get("file_name"),
                "metadata": obj.get("metadata"),
                "namespace": obj.get("namespace"),
                "size_bytes": obj.get("size_bytes"),
                "status": obj.get("status"),
                "upload_time": obj.get("upload_time"),
                "uuid": obj.get("uuid"),
            }
        )
        return _obj
